#!/bin/bash
RED='\033[0;31m' # Red
GR='\033[0;32m'  # Green
NC='\033[0m'     # No Color


docker kill ws_live

## STEP 1
ARTIFACT_ROOT=$PWD

## build the docker
cd 1_static_analysis && docker build -t sec21_paper_258_1_static_analysis . && cd ..

## run the docker for the static analysis
docker run --name ws_sa -d --rm -it -v ${ARTIFACT_ROOT}/2_live_test/data/phpmyadmin/html/:/www/ -v ${ARTIFACT_ROOT}/1_static_analysis/share:/share/ sec21_paper_258_1_static_analysis

## build the project
docker exec -it ws_sa  make

## run the static analysis
docker exec -it ws_sa ./profile_application.sh /www/ /share/filter

## stop the docker container for the static analysis
docker stop ws_sa

## STEP 2

cd $ARTIFACT_ROOT/2_live_test/

## copy the system-call filter 
cp $ARTIFACT_ROOT/1_static_analysis/share/filter ./data/phpmyadmin/filter

## build the docker for the live test
docker build --build-arg SITE_DIR=./data/phpmyadmin/ -t sec21_paper_258_2_live_test_phpmyadmin .

docker run --name ws_live -d  --security-opt apparmor=unconfined --rm -it  sec21_paper_258_2_live_test_phpmyadmin

## get the ip of running docker container
IP=$(docker inspect ws_live --format '{{ .NetworkSettings.IPAddress }}')

sleep 10

python3 $ARTIFACT_ROOT/2_live_test/data/phpmyadmin/CVE-2018-12613.py -u admin -p admin -U http://$IP

echo "A protected phpmyadmin site is accessible at http://${IP}/"
read -p "Press enter to stop the site..."
